include \masm32\include\masm32rt.inc
include CpuID.inc

.686
.xmm
include \masm32\macros\timers.asm

	LOOP_COUNT = 10000000
	SaveRegs	= 0

atol2	PROTO: DWORD
atol	PROTO: DWORD
atodjj	PROTO: DWORD
a2dwLIB	PROTO: DWORD
a2dLingo	PROTO: DWORD

VAL MACRO arg
	invoke atodjj, reparg(arg)
 	EXITM <eax>
ENDM

.code
StrPos	db "123456789", 0
StrNeg	db "-123456789", 0

start:
	invoke ShowCPU, 1
	print chr$(13, 10, 10)

	REPEAT 2
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke atodjj, offset StrNeg
	counter_end
	print str$(eax), 9, "cycles for atodjj, offset StrNeg", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke a2dLingo, offset StrNeg
	counter_end
	print str$(eax), 9, "cycles for a2dLingo, offset StrNeg", 13, 10


;	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;		invoke atol2, offset StrNeg
;	counter_end
;	print str$(eax), 9, "cycles for atol2,  offset StrNeg", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke atol, offset StrNeg
	counter_end
	print str$(eax), 9, "cycles for atol,   offset StrNeg", 13, 10, 10


	ENDM

	REPEAT 2
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke atodjj, offset StrPos
	counter_end
	print str$(eax), 9, "cycles for atodjj, offset StrPos", 13, 10

		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke a2dLingo, offset StrPos
	counter_end
	print str$(eax), 9, "cycles for a2dLingo, offset StrPos", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke atol, offset StrPos
	counter_end
	print str$(eax), 9, "cycles for atol,   offset StrPos", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke atodw, offset StrPos
	counter_end
	print str$(eax), 9, "cycles for atodw,  offset StrPos", 13, 10, 10

;	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;		invoke atol2, offset StrPos
;	counter_end
;	print str$(eax), 9, "cycles for atol2,  offset StrPos", 13, 10

	ENDM



	print "Positive, atodw: ", 9
	invoke atodw, offset StrPos
	print str$(eax), 13, 10

	print "Positive, a2dLingo: ", 9
	invoke a2dLingo, offset StrPos
	print str$(eax), 13, 10


	print "Positive, atol:  ", 9
	invoke atol, offset StrPos
	print str$(eax), 13, 10

;	print "Positive, atol2:  ", 9
;	invoke atol, offset StrPos
;	print str$(eax), 13, 10

	print "Positive, atodjj:  ", 9
	invoke atodjj, offset StrPos
	print str$(eax), 13, 10

	print "Negative, atol:  ", 9
	invoke atol, offset StrNeg
	print str$(eax), 13, 10

;	print "Negative, atol2:  ", 9
;	invoke atol2, offset StrNeg
;	print str$(eax), 13, 10

	print "Negative, atodjj:  ", 9
	invoke atodjj, offset StrNeg
	print str$(eax), 13, 10

	print "Negative, a2dLingo:  ", 9
	invoke a2dLingo, offset StrNeg
	print str$(eax), 13, 10

	print chr$(10, "Code sizes:", 13, 10)

	print chr$("atodjj: ", 9)
	mov eax, offset atodjje-atodjj
	print str$(eax), 13, 10

	print chr$("a2dLingo: ", 9)
	mov eax, offset a2dLingoe-a2dLingo
	print str$(eax), 13, 10


	print chr$("atol:    ", 9)
	mov eax, offset atole-atol
	print str$(eax), 13, 10

	print chr$("a2dw:    ", 9)
	mov eax, offset a2dwLIBe-a2dwLIB
	print str$(eax), 13, 10

	getkey			; use getkey instead of opt_wait 1 if you want to launch the prog from Explorer
	exit				; short form of invoke ExitProcess, 0

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE

atol proc lpSrc:DWORD

	xor eax, eax		; zero EAX
	mov edx, [esp+4]
	movzx ecx, BYTE PTR [edx]
	add edx, 1
	cmp ecx, "-"		; test for sign
	jne lbl0
	add eax, 1		; set EAX if sign
	movzx ecx, BYTE PTR [edx]
	add edx, 1

	lbl0:
	push eax		; store sign on stack
	xor eax, eax		; so eax*10 will be 0 for first digit

	lbl1:
	sub ecx, 48
	jc lbl2
	lea eax, [eax+eax*4]		; mul eax by 5
	lea eax, [ecx+eax*2]		; mul eax by 2 and add digit value
	movzx ecx, BYTE PTR [edx]		; get next digit
	add edx, 1
	jmp lbl1

	lbl2:
	pop ecx		; retrieve sign
	test ecx, ecx
	jnz lbl3
	ret 4

	lbl3:
	neg eax		; negative return value is sign set
	ret 4

atol endp
atole:
 
align 4
atol2 proc lpSrc:DWORD
    xor eax, eax                ; zero EAX
    mov edx, [esp+4]
    movzx ecx, BYTE PTR [edx]
    add edx, 1

    cmp ecx, "-"                ; test for sign
    jne lbl0
    add eax, 1                  ; set EAX if sign
   
	if 1	; corrected
		movzx ecx, BYTE PTR [edx+1]
		add edx, 2
	else	; original
		movzx ecx, BYTE PTR [edx]
		add edx, 1
	endif

  lbl0:
    push eax                    ; store sign on stack

  lbl1:
    sub ecx, 48
    jc  lbl2
    lea eax, [eax+eax*4]        ; mul by 5
    lea eax, [ecx+eax*2]        

    movzx ecx, BYTE PTR [edx]
    add edx, 1
    jmp lbl1

  lbl2:
    pop ecx                     ; retrieve sign
    test ecx, ecx
    jnz lbl3
    ret 4

  lbl3:
    neg eax                     ; negative return value is sign set
    ret 4

atol2 endp
atol2e:

align 4
atodjj proc lpSrc:DWORD
  if SaveRegs
	push ecx
	push edx
	mov edx, [esp+4+8]
  else
	mov edx, [esp+4]
  endif
	movzx ecx, byte ptr [edx]
	sub ecx, "-"
	.if Zero?
		inc edx
	.endif

	push ecx					; store sign
	xor eax, eax				; zero the return value
@@:
  REPEAT 2
	movzx ecx, byte ptr [edx]
	sub ecx, 48
	jc @F
	lea eax, [eax+eax*4]		; *5
	lea eax, [ecx+eax*2]		; ecx+2*5*eax
	inc edx						; add edx, 1 faster on P4
  ENDM
	jmp @B

@@:	pop ecx						; get sign
	test ecx, ecx
	jne @F
	neg eax						; negative return value

@@:
  if SaveRegs
	pop edx
	pop ecx
  endif
	ret 4
atodjj endp
atodjje:

align 16
a2dLingo proc lpstr:dword
	pop		ecx
	pop		edx
	cmp		byte ptr [edx], "-"
	jne		@A1
	movzx  eax, byte ptr [edx+1]
	add		edx, 2
	xor		ecx, ecx
	sub		eax, 30h
@@:
  repeat 2
	add		cl, byte ptr [edx]
	jz			@f
	lea		eax, [eax+eax*4]		
	add		edx, 1
	lea		eax, [ecx+eax*2-30h]	
	xor		ecx, ecx
  endm
	jz			@b
@@:
	neg		eax
    jmp		dword ptr [esp-2*4]
align 16
@A1:
	movzx  eax, byte ptr [edx]
	add		edx, 1
	xor		ecx, ecx
	sub		eax, 30h
@@:
  repeat 2
	add		cl, byte ptr [edx]
	jz			@f
	lea		eax, [eax+eax*4]		
	add		edx, 1
	lea		eax, [ecx+eax*2-30h]	
	xor		ecx, ecx
  endm
  jz			@b
@@:
    jmp    dword ptr [esp-2*4]
a2dLingo endp
a2dLingoe:

OPTION PROLOGUE:prologuedef
OPTION EPILOGUE:epiloguedef

a2dwLIB proc uses ecx edi edx esi String:DWORD

      ;----------------------------------------
      ; Convert decimal string into dword value
      ; return value in eax
      ;----------------------------------------

      xor ecx, ecx
      mov edi, String
      invoke lstrlen, String

      .while eax != 0
        xor edx, edx
        mov dl, byte ptr [edi]
        sub dl, "0" ; subtrack each digit with "0" to convert it to hex value
        mov esi, eax
        dec esi
        push eax
        mov eax, edx
        push ebx
        mov ebx, 10
          .while esi > 0
            mul ebx
            dec esi
          .endw
        pop ebx
        add ecx, eax
        pop eax
        inc edi
        dec eax
      .endw

        mov eax, ecx
        ret

a2dwLIB endp
a2dwLIBe:

end start

RichMasm options:
OPT_Assembler	ml	; If present in \bin, JWasm.exe will be used; delete the x to force link.exe
OPT_Tmp2Asm	1
OPT_DebugL	/MERGE:.data=.rdata /MERGE:.rdata=.text	; for ultra short executables
OPT_NoWarn	LNK4254, multiple	; we ignore linker warnings found in this string, e.g. section a merged into b with different attributes
OPT_WAIT	0		; wait until a key is pressed before closing the DOS box

34      cycles for atol2, offset StrNeg
34      cycles for atodjj, offset StrNeg
30      cycles for atol2, offset StrNeg
34      cycles for atodjj, offset StrNeg
30      cycles for atol2, offset StrNeg
34      cycles for atodjj, offset StrNeg
29      cycles for atol2, offset StrNeg
35      cycles for atodjj, offset StrNeg
30      cycles for atol2, offset StrNeg
34      cycles for atodjj, offset StrNeg
Positive, atol:         12345
Positive, atol2:        12345
Positive, VAL:          12345
Negative, atol:         -112345
Negative, atol2:        -12345
Negative, VAL:          -12345

Code sizes:
atol:   60
VAL:    47
